#! /bin/bash
WINEBIN="bisheng-engine-wine8"
PACKAGE_VERSION="3.0.3"

PACKAGE_NAME="printer-driver-bisheng-sharp-al-2021"
PRINTER_NAME=( "SHARP AL-2021" "SHARP AL-2031" "SHARP AL-2041" "SHARP MX-B200" "SHARP MX-B201" "SHARP MX-B201D" "SHARP AR-5618S" "SHARP AR-5620S" "SHARP AR-5618" "SHARP AR-5620" "SHARP AR-5623" "SHARP AR-5618D" "SHARP AR-5620D" "SHARP AR-5623D" "SHARP MX-M182" "SHARP MX-M182D" "SHARP MX-M202D" "SHARP MX-M232D" "SHARP AR-5620V" "SHARP AR-6020" "SHARP AR-6023" "SHARP AR-6020D" "SHARP AR-6023D" "SHARP AR-6020N -USB-" "SHARP AR-6020NR -USB-" "SHARP AR-6023N -USB-" "SHARP AR-6023NR -USB-" "SHARP AR-6026N -USB-" "SHARP AR-6031N -USB-" "SHARP AR-6026NR -USB-" "SHARP AR-6031NR -USB-" "SHARP AR-6120N -USB-" "SHARP AR-6131N -USB-" "SHARP AR-2048N -USB-" "SHARP AR-2348N -USB-" "SHARP AR-2648N -USB-" "SHARP AR-3148N -USB-" "SHARP SF-S201N -USB-" "SHARP SF-S261N -USB-" "SHARP AR-2048NV -USB-" "SHARP AR-2348NV -USB-" "SHARP AR-2648NV -USB-" "SHARP AR-3148NV -USB-" "SHARP SF-S201NV -USB-" "SHARP SF-S261NV -USB-" "SHARP AR-2048S" "SHARP AR-2048D" "SHARP AR-2348D" "SHARP AR-2348S" "SHARP SF-S201S" "SHARP AR-2048SV" "SHARP AR-2048DV" "SHARP AR-2348DV" "SHARP AR-2348SV" "SHARP SF-S201SV" "SHARP AR-5618N" "SHARP AR-5620N" "SHARP AR-5623N" "SHARP AR-5623NV" "SHARP AR-6020N" "SHARP AR-6020NR" "SHARP AR-6023N" "SHARP AR-6023NR" "SHARP AR-6026N" "SHARP AR-6031N" "SHARP AR-6026NR" "SHARP AR-6031NR" "SHARP AR-6120N" "SHARP AR-6131N" "SHARP AR-2048N" "SHARP AR-2348N" "SHARP AR-2648N" "SHARP AR-3148N" "SHARP SF-S201N" "SHARP SF-S261N" "SHARP AR-2048NV" "SHARP AR-2348NV" "SHARP AR-2648NV" "SHARP AR-3148NV" "SHARP SF-S201NV" "SHARP SF-S261NV" )

CONTAINER_PATH="$HOME/.deepinwine/$PACKAGE_NAME"
OPT_PATH="/opt/deepinwine/printer_drv/$PACKAGE_NAME"
REGDIR="reg"
FILEDIR="files"

PRINTER_C=$1
found=0
for name in "${PRINTER_NAME[@]}"; do
    if [ "$PRINTER_C" = "$name" ]; then
        found=1
        break
    fi
done

if [ $found -eq 0 ]; then
    echo "printer $PRINTER_C not found"
    exit 0
fi

if [ -z "$PACKAGE_NAME" -o ! -d "$OPT_PATH" ]; then
    exit 1
fi

if [ -d "$CONTAINER_PATH" ]; then
    # compare version
    if [ ! -f "$CONTAINER_PATH/VERSION" ] || [ "$(cat "$CONTAINER_PATH/VERSION")" != "$PACKAGE_VERSION" ]; then
        rm -rf "$CONTAINER_PATH"
    fi
fi

WININI="$CONTAINER_PATH/drive_c/windows/win.ini"
if [ -f  $WININI ]; then
    grep -q "^$PRINTER_C=winerp.drv,USB" "$WININI" && exit 0
fi

if [ -d "$OPT_PATH/$REGDIR" ]; then
    find "$OPT_PATH/$REGDIR" -type f -regex ".*\.reg" | while read file; do
        WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "$file"
    done
fi

if [ -d "$OPT_PATH/$FILEDIR" ]; then
    find "$OPT_PATH/$FILEDIR" -not -type d | while read file; do
        path="$CONTAINER_PATH/drive_c/${file#*$FILEDIR/}"
        dir="${path%/*}"
        mkdir -p "$dir"
        cp -d "$file" "$path"
    done
fi

if [ -f "$WININI" ]; then
    grep -q "^\[devices\]" "$WININI" || sed -i -e "$ a [devices]" "$WININI"
    grep -q "^\[PrinterPorts\]" "$WININI" || sed -i -e "$ a [PrinterPorts]" "$WININI"
    sed -i -e "/^\[devices\]/a $PRINTER_C=winerp.drv,USB" "$WININI"
    sed -i -e "/^\[PrinterPorts\]/a $PRINTER_C=winerp.drv,USB,15,45" "$WININI"
fi

WINESERVER_RUNNING=1
WINESERVER_FINDNUM=0
while [ $WINESERVER_RUNNING -eq 1 ]
do
        WINESERVER_PATH=`ps -aux|grep wineserver|grep -v grep`
        if [ "$WINESERVER_PATH" = "" ] || [ $WINESERVER_FINDNUM -eq 3 ]; then
                WINESERVER_RUNNING=0
        else
                let WINESERVER_FINDNUM+=1
                sleep 1
        fi
done

echo "$PACKAGE_VERSION" > "$CONTAINER_PATH/VERSION"
echo "$PRINTER_NAME" > "$CONTAINER_PATH/name.log"

WINEPREFIX="$CONTAINER_PATH" $WINEBIN winecfg -v win7
WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "/opt/deepinwine/printer_drv/printer-driver-bisheng-sharp-al-2021/winprint.reg"
WINEPREFIX=$CONTAINER_PATH $WINEBIN wineserver -w 
